package eu.clarin.cmdi.mdservice.action;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.log4j.Logger;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import com.opensymphony.xwork2.ActionSupport;

import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.Helpers;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.model.Diagnostics;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;
import eu.clarin.cmdi.mdservice.proxy.ProxyInterface;



/**
 * main Struts2 controller (ie implemenets the struts' execute()-method), all other Actions are derived from.   
 * Defines the methods used for retrieving the data 
 * and provides basic implementation where possible.
 * Also responsible for caching and transformation of the result. 
 *  
 * @author vronk
 */
public class GenericAction extends ActionSupport 
implements ServletRequestAware 
{
	public static Logger log = Logger.getLogger("GenericAction");
	private static final long serialVersionUID = 1L;
	
	
	private Diagnostics diagnostics;
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */
	private String actionkey = "generic";
	private String q;
	private String format = "xml";
	
	private String actionContentType;
	private String userMsg;
	private HttpServletRequest request; 
	private long duration = 0;
	private InputStream resultStream;
	private InputStream sourceStream;
	
	private Map<String,String[]> params;
	
	private ProxyInterface target_proxy;
		
	 			
	public ProxyInterface getTargetProxy() {
		return target_proxy;
	}

	public void setTargetProxy(ProxyInterface proxy) {
		target_proxy = proxy;
		target_proxy.setSourceAction(this);
	}

/**
 * Empty implementation, subclasses have to decide themselves, which proxy to take.
 */	
	public void setTargetProxy() {
	}

	 public Diagnostics getDiagnostics(){
		 if (diagnostics == null){
			 diagnostics  = new Diagnostics();
		 }
		 return this.diagnostics;
	 }
	 
	 public void setDiagnostics(Diagnostics diagnostics){
		 this.diagnostics = diagnostics;
	 }
	 
	 public String getQ() {
			return q;
	 }

	 public void setQ(String q) {
			this.q = q;
	 }
	
	 public void setFormat(String format) {
			this.format = format;
	 }
	
	 public String getActionkey() {
			return actionkey;
		}

	public void setActionkey(String actionKey) {
			actionkey = actionKey;
		}
		
	 public String getScanClause() {
		 return getParam("scanClause");
	 }
	 public String getRecordPacking() {
		 return getParam("recordPacking");
	 }
	 public String getQuery() {
		 return getParam("query");
	 }
	 public String getStartRecord() {
		 return getParam("startRecord");
	 }
	 public String getMaximumRecords() {
		 return getParam("maximumRecords");
	 }
	 public String getFormat() {
			return getParam("format");
	 }
	 public String getCache() {
			return getParam("cache");
	 }
	 public String getRepository() {
			return getParam("repository");
	 }
	 public String getLang() {
			return getParam("lang");
	 }
	 public String getCollections() {
			return getParam("collections");
	 }
	 public String getColumns() {
			return getParam("columns");
	 }
	  public String getMaxdepth() {
		 return getParam("maxdepth");
	 }
	 
	
	/**
	 * is used in struts.xml to dynamically set the mime-type of the result, depending on the format-parameter
	 * @return
	 */
	public String getActionContentType() {
		if (this.getFormat().toLowerCase().startsWith("html")) {
			this.actionContentType = "text/html";		
			//this.actionContentType = "application/xhtml+xml";
		} else {
			this.actionContentType = "text/xml";
		}
		
		return actionContentType;
	}

	public void setActionContentType(String actionContentType) {
		this.actionContentType = actionContentType;
	}


	public String getFullFormat() {		
		return actionkey + "2" + getFormat();
	}


	/**
	 * TODO: this should be replaced by the diagnostics-mechanism
	 * @return
	 */
	public String getUserMsg() {
		return userMsg;
	}

	public void setUserMsg(String userMsg) {
		this.userMsg = this.userMsg + "\n" + userMsg;
	}
	
	/**
	 * needed to acquire the original ServletRequest 
	 * (want to access the raw params - in loadParams())
	 * @return
	 */
	@Override
	public void setServletRequest(HttpServletRequest arg0) {
		request = arg0;
	}

	public HttpServletRequest getServletRequest() {
		return request;	
	}

	/**
	 * The stream holding the resulting data to be sent back to the user as response
	 * @return
	 */
	public InputStream getResultStream() {
	        return resultStream;
    }
	public void setResultStream(InputStream _resultStream){
		resultStream = _resultStream;
	}
	public void setSourceStream(InputStream _sourceStream){
		sourceStream = _sourceStream;
	}
	
	 
	/**
	 * Get the sourceStream from the target proxy	 
	 * @return
	 * @throws IOException
	 * @throws NoStylesheetException
	 */
		public InputStream getSourceStream() throws IOException, NoStylesheetException {		
			return getTargetProxy().getSourceStream(); 
		}
		
	/**
	 * Reads in all the parameters of the request into an internal structure.
	 * the Map is not Map&lt;String,String&gt;, but rather Map&lt;String,String[]&gt;, 
	 * ie the value is an array of Strings! <a href="http://download.oracle.com/docs/cd/E17802_01/webservices/webservices/docs/1.5/api/javax/servlet/ServletRequest.html#getParameterMap%28%29" >javadocs:ServletRequest.getParameterMap()</a>
	 * 
	 * This shall allow more flexibility in using the parameters in the subclasses (and less getter/setter stuff)
	 * at the cost of circumventing the Struts-way.
	 */
	public void addParam(String key, String value){
			String[] sarr = new String[1];
			sarr[0] = value;
			params.put(key, sarr);	
	}
	
	/*
	 * sru params
	 *  /*
     * version
     * operation
     * query
     * scanClause
     * startRecord
     * maximumRecords
     * recordPacking
     * recordSchema
     * recordXPath
     * resultSetTTL
     * sortKeys
     * stylesheet
     * x-cmd-repository
     * x-cmd-collections
     * x-cmd-columns
     * x-cmd-lang
     * x-cmd-format
     * x-cmd-cache
     * x-cmd-maxdepth
	 */
	@SuppressWarnings("unchecked")
	protected void loadParams() {		
		params = new HashMap(getServletRequest().getParameterMap());

		if (getQ() != null) {
			addParam("q",getQ());
		}	

		// set defaults
		if ( params.get("version") == null){
			addParam("version","1.2");
		}
		if ( params.get("operation") == null){
			addParam("operation","searchRetrieve");
		}
		if ( params.get("query") == null){
			addParam("query",getParam("q"));
		}
		if ( params.get("startRecord") == null){
			addParam("startRecord","1");
		}
		if ( params.get("maximumRecords") == null){
			addParam("maximumRecords","50");
		}
		
		if ( params.get("x-cmd-maxdepth") == null){
			if (params.get("maxdepth") == null){
				addParam("maxdepth","2");
			} 
		} else {
			addParam("maxdepth",params.get("x-cmd-maxdepth")[0]);
		}
		
		if ( params.get("x-cmd-repository") == null){
			if (params.get("repository") == null){
				addParam("repository",WorkspaceProfile.getRepositoryByIndex(0));
			} 
		} else {
			addParam("repository",params.get("x-cmd-repository")[0]);
		}
		
		if ( params.get("x-cmd-cache") == null){
			if (params.get("cache") == null){
				addParam("cache",Cache.SKIP);
			} 
		} else {
			addParam("cache",params.get("x-cmd-cache")[0]);
		}
		
		if ( params.get("x-cmd-lang") == null){
			if (params.get("lang") == null){
				addParam("lang","en");
			} 
		} else {
			addParam("lang",params.get("x-cmd-lang")[0]);
		}
		
		if ( params.get("x-cmd-format") == null){
			if (params.get("format") == null){
				if (this.format == null) {
					addParam("format","xml");
				} else if (this.format.equals("")){
					addParam("format","xml");
				} else {
					addParam("format",this.format);
				}
			} 
		} else {
			addParam("format",params.get("x-cmd-format")[0]);
		}

		addParam("fullformat",getFullFormat());
		
	}
        
	public Map<String,String[]> getParams() {		
		return params;
	}

	
	/**
	 * This is for simplified access to the the values of the request-parameters 
	 * They are stored in the parameters-map as a String-array, 
	 * but in most(?) situations, we expect just a simple string. 
	 * @param key
	 * @return
	 */
	public String getParam(String key) {
		String v = "";
		if (!(params.get(key)==null)) v=(String)params.get(key)[0];
		return v;
	}

	public String[] getParamArray(String key) {
		String[] a = null;
		if (!(params.get(key)==null)) a=(String[])params.get(key);
		return a;
	}

	/**
	 * Constructs an unambiguous key for the request (encoding all the parameters).
	 * This is used as identifier for caching 
	 * @return key unambiguously encoding the request
	 */
	
	 public String getRequestKey() {
			String key="";
			if (getActionkey()!=null) {
				key += getActionkey() + "//-" ;
			}else {
				key +="//-" ;
			}
			if (getQuery()!=null) {
				key += getQuery() + "//-" ;
			} else {
				key +="//-" ;
			}
			if (getCollections()!=null) {
				key += getCollections() + "//-";
			} else {
				key +="//-" ;
			}
			if (this.getStartRecord()!=null) {
				key += getStartRecord() + "//-";
			}
				else{
					key +="//-" ;
			}
			if (getMaximumRecords()!=null) {
				key += getMaximumRecords() + "//-";
			}
			else{
				key +="//-" ;
			}
			
			key += getRepository()  + "//-";
			key += getMaxdepth()  + "//-";
			
			if (getLang()!=null) {
				key += getLang() + "//-";
			}else{
				key +="//-" ;
			}			

		return key;
	}
	
	 
	public String addDurationKey(){
		String req_key = getRequestKey();
	
		Double duration_d;

	    duration_d = (double)duration; 
	    duration_d = duration_d/1000.0;
		req_key += duration_d + "//-";
		return req_key;
	}
	
	/*
	private static final Map<String, String> xsl_map; 
    static { 
    	Map<String, String> aMap = new HashMap<String,String>(); 
        aMap.put("fullformat","format"); 
        //aMap.put("format","fullformat");
        aMap.put("columns", "cols");
        aMap.put("maximumItems","maximumItems"); 
        aMap.put("startItem", "startItem");
        aMap.put("lang","lang"); 
        aMap.put("q", "q");
        aMap.put("repository","repository_name"); 
        //aMap.put("repository_type", "repository_type"); 
        xsl_map = Collections.unmodifiableMap(aMap); 
    } 
    
	public Map<String,String> createTransformerParams(){
		
		Map<String, String> map = new HashMap<String, String>();

		Set<Entry<String, String[]>> set = getParams().entrySet();
		Iterator<Entry<String, String[]>> i = set.iterator();

	    while(i.hasNext()){
	      Map.Entry<String,String[]> e = (Map.Entry<String,String[]>)i.next();
	      if (xsl_map.containsKey((String)e.getKey())) {
	    	  map.put(xsl_map.get((String)e.getKey()), (String)e.getValue()[0]);
	      }
	      
	    }
	    return map;
	}
	
	public Map<String,String> createTransformerParams(){
		
		HashMap<String,String> hm = new HashMap<String,String>();
		
	    if (getFullFormat() != null){
			hm.put("format", getFullFormat());
	    }
	    
		if (getColumns() != null){
			hm.put("cols", getColumns());
		} else {
			hm.put("cols", "");
		}
		if (getStartItem() != null){
			hm.put("startItem", getStartItem());
		}
		if (getMaximumItems() != null){
			hm.put("maximumItems", getMaximumItems());	
		}
		if (getLang() != null){
			hm.put("lang", getLang());
		}
		if (getQ() != null){
		  	hm.put("q", getQ());
		}
		//if (getRepository() != null){
	        hm.put("repository_name", String.valueOf(getRepository()));
	        hm.put("repository_type", WorkspaceProfile.getRepositoryType(this.getRepository()));
		//}
      
		return hm;		
	}
	  */
	
	/**
	 * This is the work-horse function.
	 * It does two things: 
	 * a) check if the source data is already in cache (based on cache-key that is constructed from the request parameters)
	 * b) if format-parameter provided, invokes the transformation. 
	 * at the end the data to be returned as result is contained in the resultStream
	 * If format is xml, then the data from sourceStream is passed further as resultStream. 
	 *    
	 * @throws Exception  This is handled by struts (is mapped to some result in struts.xml based on the Exception-Class)
	 */
	
	public void prepare()  {
			
		try{
			loadParams();
			setTargetProxy();
			getTargetProxy().checkParams();
			
			String req_key = getRequestKey();
			log.debug("request_key: " +  req_key); 
			log.debug("params.size: " +  params.size());
			log.debug(getActionkey() + ".targetURL: " + getTargetProxy().getTargetRequest() + " .format:" + getFullFormat());
			
			// Caching
			String xcid;
		
			if (getCache().equals(Cache.SKIP)) {
				
				sourceStream = getSourceStream();
				
			} else { 
				if (getCache().equals(Cache.USE)) {
						sourceStream = Cache.getCache().getFromCache(req_key);
				}
				if (sourceStream == null) { // either not in cache or cache_flag=refresh
					//sourceStream = getTargetRequest().openStream();
					long startMillis = System.currentTimeMillis();
					sourceStream = getSourceStream();
					duration = System.currentTimeMillis() - startMillis;
					req_key = addDurationKey();
					
					long now = System.currentTimeMillis();
					xcid = Cache.getCache().putInCache(req_key,sourceStream);			
					//Admin.notifyUser("putting in cache: " + req_key);			
					sourceStream = Cache.getCache().getFromCache(req_key);
				} /* else {
					Admin.notifyUser("reading from cache: " + req_key);
				} */
			}
			
			// add diagnostics non fatal
			if (getDiagnostics().Exists()){
				Document doc ;
				Node r_element;
				// fatal error 
				//TODO getDiagnostics().Exists("fatal");
				if (sourceStream == null){
					//TODO rootelemname ???
					doc = Helpers.createDocument("rootelemname");
					r_element = doc.getFirstChild();
				} else {
					doc = Helpers.getDocument(sourceStream);
					//TODO tagname by class
					r_element=  doc.getElementsByTagName("searchRetrieveResponse").item(0);
				}
				
				Document ddoc = getDiagnostics().buildXMLDocument();
				Node d_element=  ddoc.getElementsByTagName("diagnostics").item(0);
				doc.adoptNode(d_element);
				r_element.appendChild(d_element);
				DOMSource source = new DOMSource(doc);   
				StringWriter xmlAsWriter = new StringWriter();   
				StreamResult result = new StreamResult(xmlAsWriter);    
				TransformerFactory.newInstance().newTransformer().transform(source, result);
				this.setSourceStream(new ByteArrayInputStream(xmlAsWriter.toString().getBytes("UTF-8")));
			}
			
			log.debug("format: " + getFormat() );
			if (getFormat().equals("xml")) {			
				resultStream = sourceStream;	
			}else {
				MDTransformer transformer = new MDTransformer();
				// set URL as srcFile (for MDTransformer to pass to xsl-scripts)
				// TODO: WHY??
				transformer.setSrcFile(getTargetProxy().getTargetRequest());
				//transformer.setParams(createTransformerParams());
				transformer.setParams(getParams());
				// here the transformation is invoked
				resultStream = transformer.transformXML(sourceStream);
			}

		}catch (Exception e){
			//TODO add exception to diagnostic ?
			return;
		}
		
		log.debug(getActionkey() + " success:" + (resultStream!=null));
	}

	/**
	 * default Action method that gets called by Struts. Everything interesting happens in prepare()
	 */
	public String execute() throws Exception {
//		HttpServletRequest request = ServletActionContext.getRequest();
		//Admin.notifyUser("session-attrs:");
        //Admin.notifyUser(getServletRequest().getRemoteUser() );
        //Admin.notifyUser(String.valueOf(getSession()));
        
        long now = System.currentTimeMillis();

		prepare();
		long duration = (System.currentTimeMillis() - now);
		//duration

		if (resultStream == null) {
			if (getDiagnostics().Exists()){
				Document doc ;
				Node r_element;
				// fatal error 
				//TODO getDiagnostics().Exists("fatal");
				doc = Helpers.createDocument("Error");
				r_element = doc.getFirstChild();
				
				Document ddoc = getDiagnostics().buildXMLDocument();
				Node d_element=  ddoc.getElementsByTagName("diagnostics").item(0);
				doc.adoptNode(d_element);
				r_element.appendChild(d_element);
				DOMSource source = new DOMSource(doc);   
				StringWriter xmlAsWriter = new StringWriter();   
				StreamResult result = new StreamResult(xmlAsWriter);    
				TransformerFactory.newInstance().newTransformer().transform(source, result);
				this.setResultStream(new ByteArrayInputStream(xmlAsWriter.toString().getBytes("UTF-8")));

			}
			return ERROR;	
		} else {
			return SUCCESS;
		}		
	}


}