package eu.clarin.cmdi.mdservice.model;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.xml.transform.TransformerException;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import eu.clarin.cmdi.mdservice.internal.Admin;
import eu.clarin.cmdi.mdservice.action.GenericProxyAction;
import eu.clarin.cmdi.mdservice.internal.Helpers;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.action.WorkspaceAction;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;

/**
 
 */



public class WorkspaceProfile{	

	//TODO new class
	public static enum RepositoryType
	{
		MD, SRU, PAZPAR,NOVALUE;

	    public static RepositoryType toRepositoryType(String str)
	    {
	        try {
	            return valueOf(str.toUpperCase());
	        } 
	        catch (Exception ex) {
	            return NOVALUE;
	        }
	    }   
	}

	private static JSONArray repositories = null;
	private static JSONObject options = null;
	
	public static String getRepositoryByIndex(int ind){
		String repository_name = null;
		
		net.sf.json.JSONArray json = WorkspaceProfile.getRepositories();
		if (json.size() > ind){
			repository_name = json.getJSONObject(ind).getString("name");
		}
		return repository_name;
		
	}
	public static JSONArray getRepositories(){
		if (repositories == null){
			try {
				WorkspaceProfile.setRepositories(WorkspaceProfile.createRepositories());
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoStylesheetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return repositories;
	}
	
	public static void setRepositories(JSONArray rep){
		WorkspaceProfile.repositories = rep;
	}
	
	public static JSONObject getOptions(){
		if (options == null ) {
			try {
				WorkspaceProfile.setOptions(WorkspaceProfile.createOptions());
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (TransformerException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoStylesheetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return options;
	}
	
	public static void setOptions(JSONObject op){
		WorkspaceProfile.options = op;
	}
	
	public WorkspaceProfile() {
	}
	
	public static JSONArray createRepositories() throws IOException, InterruptedException, TransformerException, NoStylesheetException{
		String path = Admin.getConfig().getProperty("workspaceprofile.path") + WorkspaceAction.WORKSPACE_FILENAME;//PROFILENAME_SERVER;
		File file=new File(path);
		InputStream in  = new BufferedInputStream( new FileInputStream(path));;
		
		MDTransformer transformer = new MDTransformer();
		transformer.setSrcFile(file.toURI().toURL());
		transformer.setParams(MDTransformer.createParamsMap("xml2json"));
		InputStream jsonstream = transformer.transformXML(in);
		
		JSONObject json = JSONObject.fromObject(Helpers.convertStreamToString(jsonstream));
		JSONArray wparray = json.getJSONObject("Profiles").getJSONArray("WorkspaceProfiles");
		JSONArray array = null;
		for (int i = 0; i < wparray.size(); ++i) {     
			JSONObject wp = wparray.getJSONObject(i); 
			if (wp.get("Repositories") != null){
				array = wp.getJSONArray("Repositories");
				break;
			}
		}	
		
		// repository as static variable
		return array;
	
		// repository as session attribute
		/*
		HttpSession session = getServletRequest().getSession();
		//JSONArray param = (JSONArray) session.getAttribute("repositories");
		JSONArray param = new JSONArray();
        param.add(array);
        session.setAttribute("repositories", param);
		 */
	}
	
	public static JSONObject createOptions() throws IOException, InterruptedException, TransformerException, NoStylesheetException{
		String path = Admin.getConfig().getProperty("workspaceprofile.path") + WorkspaceAction.WORKSPACE_FILENAME;//PROFILENAME_SERVER;
		File file=new File(path);
		InputStream in  = new BufferedInputStream( new FileInputStream(path));;
		
		MDTransformer transformer = new MDTransformer();
		transformer.setSrcFile(file.toURI().toURL());
		transformer.setParams(MDTransformer.createParamsMap("xml2json"));
		InputStream jsonstream = transformer.transformXML(in);
		
		JSONObject json = JSONObject.fromObject(Helpers.convertStreamToString(jsonstream));
		JSONArray wparray = json.getJSONObject("Profiles").getJSONArray("WorkspaceProfiles");
		JSONObject obj = null;
		for (int i = 0; i < wparray.size(); ++i) {     
			JSONObject wp = wparray.getJSONObject(i); 
			if (wp.get("Options") != null){
				obj = wp.getJSONObject("Options");
				break;
			}
		}	
		
		// options as static variable
		return obj;
	
	}
	
	public static String getOption(String opt_key){
		String option_val = null;
		
		net.sf.json.JSONObject json = getOptions(); 
		option_val = json.getString(opt_key);

		return option_val;
		
	}
	
	public static Boolean repositoryExists(String repository_name){
			
			// static repositories
			net.sf.json.JSONArray json = WorkspaceProfile.getRepositories(); 
			for(int i=0;i<json.size();i++){
				if (json.getJSONObject(i).getString("name").equals(repository_name)){
					return true;
				}
			}
			
			return false;

		}
	
	public static String getRepositoryPath(String repository_name){
		String repository_path = null;
		
		
		
		// static repositories
		net.sf.json.JSONArray json = WorkspaceProfile.getRepositories(); 
		for(int i=0;i<json.size();i++){
			if (json.getJSONObject(i).getString("name").equals(repository_name)){
				repository_path =  json.getJSONObject(i).getString("uri");
			}
		}
		
		return repository_path;
		
	}
	
	public static String getRepositoryType(String repository_name){
	String typestr = "";
		
		
		// static repositories
		net.sf.json.JSONArray json = WorkspaceProfile.getRepositories(); 
		for(int i=0;i<json.size();i++){
			if (json.getJSONObject(i).getString("name").equals(repository_name)){
				typestr =  json.getJSONObject(i).getString("type");
			}
		}
		
		return (typestr);

	}
	public static Boolean isSRURepository(String repository_name){
		//Boolean issru = false;
		String typestr = getRepositoryType(repository_name);
		
		return (typestr.equals("sru"));
		
	}


}


